#ifndef SELECTEUR_CONVERSION_H
#define SELECTEUR_CONVERSION_H

#include "EstConvertible.h"

template <class Src, class Dest>
   struct ConversionStatique
   {
      static Dest executer (const Src _src)
      {
         return static_cast<Dest> (_src);
      }
   };
template <class Src, class Dest>
   struct ConversionDynamique
   {
      static Dest executer (const Src _src)
      {
         return dynamic_cast<Dest> (_src);
      }
   };

template <bool, class SiVrai, class SiFaux>
   struct StaticIfElse;
template <class SiVrai, class SiFaux>
   struct StaticIfElse <true, SiVrai, SiFaux>
   {
      typedef SiVrai resultat_t;
   };
template <class SiVrai, class SiFaux>
   struct StaticIfElse <false, SiVrai, SiFaux>
   {
      typedef SiFaux resultat_t;
   };

template <class Src, class Dest>
   struct SelecteurConversion
   {
      typedef typename
         StaticIfElse
         <
            EstConvertible<Src, Dest>::VALEUR,
            ConversionStatique<Src, Dest>,
            ConversionDynamique<Src, Dest>
         >::resultat_t conversion_t;
   };

template <class Dest, class Src>
   Dest Convertir (Src _src)
   {
      return SelecteurConversion<Src, Dest>::conversion_t::executer (_src);
   }


#endif
